<?php 

add_shortcode('DAPUserLinks', 'dap_userlinks');

function addDAPCSS() {
	wp_register_style('dap-css', getCssFullURL());
	wp_enqueue_style('dap-css');
}

function dap_userlinks($atts, $content=null){ 
	extract(shortcode_atts(array(
		'showproductname' => 'Y',
		'showaccessstartdate' => 'Y',
		'showaccessenddate' => 'Y',
		'showdescription' => 'Y',
		'showlinks' => 'Y',
		'orderoflinks' => 'NEWESTFIRST',
		'howmanylinks' => '10000',		
		'errmsgtemplate' => 'SHORT',
		'productid' => 'ALL',
		'dateformat' => 'MM-DD-YYYY'
	), $atts));
	
	$content = do_shortcode(dap_clean_shortcode_content($content));	
	
	$session = Dap_Session::getSession();
	$user = $session->getUser();
	$userProducts = null;
	//$content = $content . "<br/><br/>";
	
	if( !Dap_Session::isLoggedIn() || !isset($user) ) {
		//logToFile("Not logged in, returning errmsgtemplate");
		return getErrorMessage($errmsgtemplate);
	}
	
	if( Dap_Session::isLoggedIn() && isset($user) ) { 
		//get userid
		$userProducts = Dap_UsersProducts::loadProducts($user->getId());
	}

	$content = USER_LINKS_YOUCURRENTLYHAVEACCESSTO_TEXT . count($userProducts). USER_LINKS_PRODUCTS_TEXT;
	
	//loop over each product from the list
	foreach ($userProducts as $userProduct) { 
		if($productid != "ALL") {
			if( $userProduct->getProduct_id() != $productid ) {
				continue;
			}
		}
		
		$product = Dap_Product::loadProduct($userProduct->getProduct_id());
		$content .= '<div class="dap_product_links_table">';
		
		if(strtolower($showproductname) == "y") {
			$content .= '<div class="dap_product_heading">'.$product->getName().'</div>';
		}
		
		if(strtolower($showaccessstartdate) == "y") {
			$oldDate = $userProduct->getAccess_start_date();
			//$middle = strtotime($oldDate);
			$middle = new DateTime($oldDate);
			$stringFormat = "";
			if($dateformat == "MM-DD-YYYY") {
				$stringFormat = "m-d-Y";
			} else if($dateformat == "DD-MM-YYYY") {
				$stringFormat = "d-m-Y";
			}  else if($dateformat == "YYYY-MM-DD") {
				$stringFormat = "Y-m-d";
			}
			//$newDate = date($stringFormat, $middle);
			$newDate = $middle->format($stringFormat);

			$content .= '<div><strong>'.USER_LINKS_ACCESS_START_DATE_TEXT.'</strong>: '.$newDate.'</div>';
		}
		
		if(strtolower($showaccessenddate) == "y") {
			$oldDate = $userProduct->getAccess_end_date();
			//$middle = strtotime($oldDate);
			$middle = new DateTime($oldDate);
			$stringFormat = "";
			if($dateformat == "MM-DD-YYYY") {
				$stringFormat = "m-d-Y";
			} else if($dateformat == "DD-MM-YYYY") {
				$stringFormat = "d-m-Y";
			}  else if($dateformat == "YYYY-MM-DD") {
				$stringFormat = "Y-m-d";
			}
			//$newDate = date($stringFormat, $middle);
			$newDate = $middle->format($stringFormat);
			
			$content .= '<div><strong>'.USER_LINKS_ACCESS_END_DATE_TEXT.'</strong>: '.$newDate.'</div>';
		}
		
		if(strtolower($showdescription) == "y") {
			$content .= '<div><strong>'.USER_LINKS_DESCRIPTION_TEXT.'</strong>: '.$product->getDescription().'</div>';
		}
		
		if(strtolower($showlinks) == "y") {
			$orderBy = "asc";
			//$howmanylinks = intval($howmanylinks) + 1;
			if(strtolower($orderoflinks) == "newestfirst") {
				$orderBy = "desc";
			}
			$content .= '<div><strong>'.USER_LINKS_LINKS_TEXT.'</strong>: '.$userProduct->getActiveResources($product->getSelf_service_allowed(),$orderBy,$howmanylinks).'</div>';
		}
      	
		$content .= '</div>';
		$content .= '<br/><br/>';
	} //end foreach

	return $content;
}


?>